// FILE: CSRTS4.CPP
// MODULE: PRINT
// PROGRAM: CSRTS
////////////////////////////////////////////////////////////////////////////////
//
//     Functions:
//             print_copyright()       writes the copyright message to STDOUT.
//
//             print_copyright_err()   writes the copyright message to STDERR.
//
//             print_help()            writes the help pages to STDOUT.
//
//
////////////////////////////////////////////////////////////////////////////////

#include <fstream.h>
#include <string.h>
#include <stdio.h>
#include <math.h>
#include <ctype.h>
#include <stdlib.h>
#include <conio.h>
#include <dos.h>
#include <alloc.h>


char c_4_notice[] = " Copyright 1991, Ted Davis\
                   Sort routine after Comb Sort,\
                   Copyright 1991, McGraw-Hill";


void print_copyright(void);
void print_copyright_err(void);
void print_help(void);


void print_copyright(void)
// Prints the copyright message to STDOUT, which can be redirected.
{
    cout << "\nCSRTS 1.0, Copyright 1991, Ted Davis.\n";
    cout << "Part of the sort routine Copyright 1991, McGraw Hill.\n";
    cout << "After the Combsort routine in the Hands On section of\n";
    cout << "Byte magazine V16, #4, by Lacey and Box (much modified).\n";
    cout << "This program is FREEWARE.\n\n";
}

void print_copyright_err(void)
// Prints the copyright message to STDERR, which CANNOT be redirected.
{
    cerr << "\nCSRTS 1.0, Copyright 1991, Ted Davis.\n";
    cerr << "Part of the sort routine Copyright 1991, McGraw Hill.\n";
    cerr << "After the Combsort routine in the Hands On section of\n";
    cerr << "Byte magazine V16, #4, by Lacey and Box (much modified).\n";
    cerr << "This program is FREEWARE.\n\n";
}

void print_help(void)
// Prints the two page help message to STDOUT.
{
    print_copyright();
    cout << "\nSyntax: csrts {options} < {source file} > {destination file}\n";
    cout << "\n                        OPTIONS:\n";
    cout << "         /+{number}       - Starting column for sort\n";
    cout << "         /{number}        - Width of field to sort in columns\n";
    cout << "  or     /+{number}       - Ending column of field.\n";
    cout << "         /${number}       - The number of the field to sort\n";
    cout << "         /B or /b         - Accept blank lines\n";
    cout << "         /C or /c         - Case insensitive sort\n";
    cout << "         /H or /h         - This HELP screen\n";
    cout << "         /R or /r         - Reverse sort\n";
    cout << " /T{number} or /t{number} - Treat given field as a time field.\n";
    cout << "\n Press any key to continue ";
    getch();
    cout << " None of these arguments is required; if none is given, the sort will be\n";
    cout << " made on the entire line.  If there are two arguments in the form /+{number},\n";
    cout << " the smaller number will be taken as the starting column and the larger as\n";
    cout << " the ending column.  If there is only one, it is the starting column.\n";
    cout << " Bare numbers after a slash (or -) define the width of the field on which the\n";
    cout << " will be performed.  /${number} specifies the number of the field, 1 for first,\n";
    cout << " that will be sorted.  These fields are parsed with sscanf() and must be white\n";
    cout << " space delimited, but need not be in fixed columns.  The limit is 10.\n";
    cout << " Conflicting arguments generate warning messages and are ignored.\n";
    cout << " The program can accommodate files that are up to 750 lines long.\n";
    cout << " Line length is limited to eighty characters.  Sorting is by ASCII character\n";
    cout << " number unless the \C or \c switch is used, in which case the sort is based on\n";
    cout << " the upper case equivalents of lower case letters.\n Negative arguments are taken as positive.\n";
    cout << " If a $ argument is contains a decimal point, the field number is the part on the left,\n";
    cout << " and the field will be right justified in a field of width equal to the number to the\n";
    cout << " right of the point.  This is useful for sorting columns of numbers.\n";
    cout << " Time fields are sorted as if they were in 24 hr format from 0000 to 2400.\n";
    cout << " If an R is followed by a number, the field with that number will be reverse \n";
    cout << " sorted, if selected by a $, T, or t command.  If there is a master R command,\n";
    cout << " the given field will be normal sorted while everything else that is selected\n";
    cout << " will be reverse sorted.\n";
    cout << "\n T.E.D. 4-18-91\n\n";
}
