// FILE: CSRTS7.CPP
// MODULE: CRUNCH
// PROGRAM: CSRTS
////////////////////////////////////////////////////////////////////////////////
//
//     Function:
//             crunch_numbers()        derives unspecified variables, checks ranges
//
//
////////////////////////////////////////////////////////////////////////////////

#include <fstream.h>
#include <string.h>
#include <stdio.h>
#include <math.h>
#include <ctype.h>
#include <stdlib.h>
#include <conio.h>
#include <dos.h>
#include <alloc.h>


#define max_string_len 134

char c_7_notice[] = " Copyright 1991, Ted Davis\
                   Sort routine after Comb Sort,\
                   Copyright 1991, McGraw-Hill";
extern int start_col;                  // an index to the first column to be sorted.
extern int field_width;                // the number of characters to be sorted.
extern int flag;                       // the go-no-go flag.
extern int i, k, l, j;                 // general use integer variables
extern int numbers[3];                 // temporary storage of command tail numbers.

extern print_copyright_err(void);

void crunch_numbers(void);

void crunch_numbers(void)
// Derives variables that are not specified by the user from those that are and from
// default values, performs range checking on columns and main field width.
{
    // column number ordering
    if((numbers[0] > numbers[1]) && numbers[1] > 0)
    {
        j = numbers[0];
        numbers[0] = numbers[1];
        numbers[1] = j;
    }
    numbers[0]--; numbers[1]--;         // make zero based
    // column number range testing
    if(((numbers[0] < 0) || (numbers[0] > max_string_len )) && (numbers[0] != -2))
    {
        print_copyright_err();
        cerr << "\nFATAL ERROR: START COLUMN OUT OF RANGE\n";
        flag = -1;
    }
    if(((numbers[1] < 1) || (numbers[1] > (max_string_len - 1))) && (numbers[1] != -2))
    {
        print_copyright_err();
        cerr << "\nFATAL ERROR: END COLUMN OUT OF RANGE\n";
        flag = -1;
    }
    numbers[1]++;                       // reconvert to one based
    // set start column
    if(numbers[0] == -2)
    {
        start_col = 0;
    }
    else
    {
        start_col = numbers[0];
    }
    // compute derived field width, end - start + 1 (start is zero based, end is one based)
    field_width = numbers[1] - numbers[0];      // derived width
    if((!field_width) && (numbers[0] != -2))
    {
        print_copyright_err();
        cerr << "\nFATAL ERROR: DERIVED FIELD WIDTH IS ZERO\n";
        flag = -1;
    }
    // set field width if given rather than derived
    if(!field_width && (numbers[2] == -1))
    {
        field_width = max_string_len - start_col;      // default width
    }
    else
    {
        field_width = numbers[2];   // given width
    }
    // if all else fails, use default
    if(field_width < 0) {field_width = max_string_len - start_col;}
    // field width range test
    if((field_width < 1) || (field_width > max_string_len))
    {
        print_copyright_err();
        cerr << "\nFATAL ERROR: FIELD WIDTH IS EXCESSIVE\n";
        flag = -1;
    }
    if(!field_width)                // zero test
    {
        print_copyright_err();
        cerr << "\nFATAL ERROR: FIELD WIDTH IS ZERO\n";
        flag = -1;
    }
}
